# cPy - simple aio tg WebApp showing "Hello World"
# provided by Anthony Vogelaar, Perth Scotland
# rev 0.10  2025-02-27  initial release

import  platform
import  os;         os.system('clear')
import  asyncio
from    microdot    import  Microdot
import  webbrowser

# =========================== local ================================

def openBrowser(port=5000):
    if platform.uname().machine == 'aarch64': pass
        #qpy:webapp:'R&D WebApp'
        #qpy://127.0.0.1:5000
    else: webbrowser.open('localhost:5000', new=1)             # open een new browser window

# ========================== webserver =============================

def webServer(port=5000):
    app = Microdot()

    @app.route('/')
    async def index(request):
        return '''
<!DOCTYPE html>
<html lang="en">
    <head>
  	    <meta charset="utf-8" />
	    <link rel="icon" href="data:,">
	    <title>R&D WebApp</title>
    </head>
    <body>
        <h1 style="color: blue">Hello, world!</h1>
    </body>
</html>
''', {'Content-Type': 'text/html'}

    return app

# ============================ Main ================================

class Main:

    def __init__(self, port=5000):
        self.port = port
        openBrowser()
        asyncio.run(self.aioInit())


    # launch all aio tasks
    async def aioInit(self):
        app    = webServer()
        async with asyncio.TaskGroup() as tg:
            tg.create_task(app.start_server(port=self.port))
            tg.create_task(self._task())


    # monitor, print '*' @ 1 Hz
    async def _task(self):
        while True:
            print('*', end='', flush=True)
            await asyncio.sleep(1)


try:
    Main()
except KeyboardInterrupt:
    print('\nTerminated by Ctrl-C')

# ============================= end =================================
